//XmlMesh.h

#ifndef _XMLMESH_H
#define _XMLMESH_H

#include <vector>
#include "EDefine.h"
#include "../xmlnode/StringUtil.h"
#include "../xmlnode/XmlNode.h"

class ENode;

class XmlMesh : public XmlNode
{
public:
	XmlMesh();
	virtual ~XmlMesh();

public: 
	virtual	const char*	GetClassName();
	
	void			CreateMesh( ENode*& pParent );
protected:
	virtual ENode*	OnXmlToENode( ENode* pParent );

protected:
	virtual	void		OnUpdate();
	void				ConvertMeshInfo();
	void				ConvertTransformInfo();
	void				FetchVertex( std::vector<VertexInfo>& vertexArr );
	void				FetchFace( std::vector<base::Index3>& indexArr );
	void				ToDXMatrix( D3DXMATRIXA16& destMat, const base::Matrix& srcMat ); 

	void				SetUseData( bool bFlag );  
	bool				GetUseData();			
	void				SetUseDataChild( bool bFlag );  //UseData  ڽ  
	
private:
	//Xml ͸  ͷ ȯҰ ÷
	bool						m_bUseData;

public:
	std::vector<VertexInfo>		m_vertex;		//
	std::vector<base::Index3>	m_index;		//ε	
	D3DXMATRIXA16				m_matLocal;		//  

	
};

#endif