//XmlNo0de.inl

//ReadXml() ø Լ

//-----------------------------------------------------------------------------
template<class T> 
void _ReadXml( T* dataNode, TiXmlNode* xmlNode, T*& outNode )
{
	if(xmlNode)
	{
		switch(xmlNode->Type())
	   	{
		case TiXmlNode::COMMENT:
		    //std::cout << "COMMENT: " << xmlNode->Value() << std::endl;
		    break;
	   	case TiXmlNode::DECLARATION:
		    //std::cout << "DECLARATION: " << std::endl;
	   	    break;

	   	case TiXmlNode::ELEMENT:
	   		{
				//std::cout << "ELEMENT: [" << xmlNode->ToElement()->Value() << "]" << std::endl;
				if( outNode == NULL )
				{
					dataNode = outNode = new T;
				}
				else
				{
					T* child = new T;
					dataNode->AttachChild( child );
					dataNode = child;
				}

				dataNode->SetName( xmlNode->ToElement()->Value() );
	   			TiXmlAttribute *pAttr = xmlNode->ToElement()->FirstAttribute();
	   			while(pAttr)
	   			{
					dataNode->AddAttribute( pAttr->Name(), pAttr->Value() );
					//std::cout << pAttr->Name() << "=\"" << pAttr->Value() << "\"" << std::endl;
	   	   			pAttr = pAttr->Next();
	   			}
			}
	   		break;

	   	case TiXmlNode::TEXT:
		    TiXmlText* pText = xmlNode->ToText();
		    if(pText)
		    {
			    dataNode->SetData( pText->Value() );
			    //std::cout << "TEXT:  " << pText->Value() << std::endl;
		    }
		    break;
	   	}

	   	for(TiXmlNode *pXmlNext = xmlNode->FirstChild(); pXmlNext; pXmlNext = pXmlNext->NextSibling()) 
		    _ReadXml<T>( dataNode, pXmlNext, outNode );
	}
}
//-----------------------------------------------------------------------------
template<class T> 
T* ReadXml( const char* szName )
{
	TiXmlDocument doc;
	if ( doc.LoadFile( szName ) == false )
	{
		return NULL;
	} 

	T* parent = NULL;
	_ReadXml<T>( NULL, &doc, parent );
	return parent;
}